%Del 1
%Lage log fil som generere ulike verdier for materialparametere
%Laget med veiledning fra Ivan Depina
Start = 506;
Slutt = 1800;
%
for i=Start:Slutt
    FileOut=['D:\Skole\Var 2014\PlaxisCommands\LOGfiler\calculate' sprintf('%4.4d',i) '.log']; %definerer output fil
   
    %Tilfeldig variabel for SU *********************************************
    %Bestemmer middelverdi og varians, m=middelverdi, v=varians
    m1=38.9; %Toppleire
    v1=16.5;
    m2=32.2; %Blt Leire
    v2=14.8;
    m3=62.6; %Fast Leire
    v3=24.4;
    
    %Lognormal fordeling:    
    %Toppleire
    mu1=log((m1^2)/sqrt(v1+m1^2));
    sig1=sqrt(log(v1^2/m1^2+1));
    SU1=lognrnd(mu1,sig1);
    %Blt Leire
    mu2=log((m2^2)/sqrt(v2+m2^2));
    sig2=sqrt(log(v2^2/m2^2+1));
    SU2=lognrnd(mu2,sig2);
    %Fast Leire
    mu3=log((m3^2)/sqrt(v3+m3^2));
    sig3=sqrt(log(v3^2/m3^2+1));
    SU3=lognrnd(mu3,sig1);
    
    %Normalfordeling
    %SU1=randn(1,1)*(v1)+m1; %Toppleire
    %SU2=randn(1,1)*(v2)+m2; %Blt Leire
    %SU3=randn(1,1)*(v3)+m3; %Fast Leire
          
    %Tilfeldig variabel for Anisotropi **********************************************
    PAS1=(0.3+abs(0.15*rand(1,1)));
    DSS1=(0.5+PAS1/2);
    PAS2=(0.3+abs(0.15*rand(1,1)));
    DSS2=(0.5+PAS2/2);
    PAS3=(0.3+abs(0.15*rand(1,1)));
    DSS3=(0.5+PAS3/2);
    %Tilfeldig variabel for tyngdetetthet**********************************
    
    mt1= 20; %Toppleire
    vt1= 0.5;
    mt2= 20.1; %Blt Leire
    vt2= 0.2;
    mt3= 20; %Fast Leire
    vt3= 0.8;
    
    TT1= mt1+randn(1,1)*vt1; %Tyngdetetthet, Toppleire
    TT2= mt2+randn(1,1)*vt2; %Tyngdetetthet, Blt Leire
    TT3= mt3+randn(1,1)*vt3; %Tyngdetetthet, Fast Leire
    
    
    %pne outputfilen
    [fout,errmsg]=fopen(FileOut,'wt');
    
    %Sjekk om filen ikke er pen
    if(fout<0);
        sprintf('Filen er ikke pen');
        sprintf('Error Message. %s', errmsg);
    end
    
    %sjekk om filen er pen
    if(fout>=0);
        
        %Endring av verdier for de tre verste lagene. sprintf() er
        %benyttet for  sette inn verdier p riktig plass
        %Endring av SU, DSS, (PAS)sive og TyngdeTetthet(TT)
        %for de tre verste lagene: Toppleire, Blt Leire og Fast Leire
           fprintf(fout,['sps Toppleire "Comments" "" "MaterialName" "Toppleire" "Colour" 10676870 "MaterialNumber" 0 "SoilModel" 9 "UserDefinedIndex" 0 "DrainageType" 2 "DilatancyCutOff" False "UndrainedBehaviour" 0 "InterfaceStrength" 0 "ConsiderGapClosure" True "K0PrimaryIsK0Secondary" True "K0Determination" 0 "DefaultValuesAdvanced" True "DataSetFlow" 0 "ModelFlow" 0 "UDModelFlow" 0 "SoilTypeFlow" 0 "LowerUpper" 0 "UsdaSoilType" 0 "StaringUpperSoilType" 0 "StaringLowerSoilType" 0 "M50" 0 "DefaultValuesFlow" False "TablePsiPermSat" "[0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]" "SplinePsiPerm" "[0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]" "SplinePsiSat" "[0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]" 13554.6 0.3 0 ' sprintf('%d',SU1) ' 0 0.1 0 0 ' sprintf('%d',TT1) ' ' sprintf('%d',TT1) ' 0 0 1 0 0 0 0 0 0 0.333333333333333 0 0.999 0 0 0 0 1.00000000000000000E+015 0.495 0 0 300 0.99 0 0 0 ' sprintf('%d',DSS1) ' ' sprintf('%d',PAS1) ' 0.7 0.666666666666667 2.4 3.33333333333333 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 1 1 1 0 0 -1.06 -2.37 0 0 10000 1 0.0620347394540943 3.83 1.3774 1.25 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n']);
           fprintf(fout,['sps BltLeire "Comments" "" "MaterialName" "Blt leire" "Colour" 9664513 "MaterialNumber" 0 "SoilModel" 9 "UserDefinedIndex" 0 "DrainageType" 2 "DilatancyCutOff" False "UndrainedBehaviour" 0 "InterfaceStrength" 0 "ConsiderGapClosure" True "K0PrimaryIsK0Secondary" True "K0Determination" 1 "DefaultValuesAdvanced" True "DataSetFlow" 0 "ModelFlow" 0 "UDModelFlow" 0 "SoilTypeFlow" 0 "LowerUpper" 0 "UsdaSoilType" 0 "StaringUpperSoilType" 0 "StaringLowerSoilType" 0 "M50" 0 "DefaultValuesFlow" False "TablePsiPermSat" "[0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]" "SplinePsiPerm" "[0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]" "SplinePsiSat" "[0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]" 3851.13 0.3 0 ' sprintf('%d',SU2) ' 0 0.1 0 0 ' sprintf('%d',TT2) ' ' sprintf('%d',TT2) ' 0 0 1 0 0 0 0 0 0 0.333333333333333 0 0.999 0 0 0 0 1.00000000000000000E+015 0.495 0 0 200 0.99 0 0 0 ' sprintf('%d',DSS2) ' ' sprintf('%d',PAS2) ' 0.7 0.666666666666667 2.4 3.33333333333333 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 1.00000000000000000E+010 1.00000000000000000E+010 1 0 0 -1.06 -2.37 0 0 10000 1 0.0620347394540943 3.83 1.3774 1.25 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n']);
           fprintf(fout,['sps FastLeire "Comments" "" "MaterialName" "Fast Leire" "Colour" 10602216 "MaterialNumber" 0 "SoilModel" 9 "UserDefinedIndex" 0 "DrainageType" 2 "DilatancyCutOff" False "UndrainedBehaviour" 0 "InterfaceStrength" 0 "ConsiderGapClosure" True "K0PrimaryIsK0Secondary" True "K0Determination" 0 "DefaultValuesAdvanced" True "DataSetFlow" 0 "ModelFlow" 0 "UDModelFlow" 0 "SoilTypeFlow" 0 "LowerUpper" 0 "UsdaSoilType" 0 "StaringUpperSoilType" 0 "StaringLowerSoilType" 0 "M50" 0 "DefaultValuesFlow" False "TablePsiPermSat" "[0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]" "SplinePsiPerm" "[0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]" "SplinePsiSat" "[0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]" 11110 0.3 0 ' sprintf('%d',SU3) ' 0 0.1 0 0 ' sprintf('%d',TT3) ' ' sprintf('%d',TT3) ' 0 0 1 0 0 0 0 0 0 0.333333333333333 0 0.999 0 0 0 0 1.00000000000000000E+015 0.495 0 0 300 0.99 0 0 0 ' sprintf('%d',DSS3) ' ' sprintf('%d',PAS3) ' 0.7 0.666666666666667 2.4 3.33333333333333 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 1 1 1 0 0 -1.06 -2.37 0 0 10000 1 0.0620347394540943 3.83 1.3774 1.25 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n']);
           
         

        
        %PLAXIS-kommandoer for  starte beregningene:
        fprintf(fout,'gotostages\n');     %Gr til stages
        fprintf(fout,'set InitialPhase.ShouldCalculate True\n'); %gjr at InitialPhase regnes ut
        fprintf(fout,'set Phase_1.ShouldCalculate True\n');      %gjr at Phase_1 regnes ut
        fprintf(fout,'Calculate\n'); %gjr at beregningene starter
        fprintf(fout,'Save\n'); %Lagrer prosjektet
        fprintf(fout,'__Kill\n'); %lukker prosjektet
        
        fclose(fout);
    end
end

%******************************************************************
%Del 2
%Lage batch fil som kjrer .log filen

%Lag .bat filen
FileBatOut=['D:\Skole\Var 2014\PlaxisCommands\runcalculation1.bat'];
        
%pne .bat filen
[fbat,errmsg]=fopen(FileBatOut,'wt');

%sjekk om filen er pen
if(fbat<0)
    sprintf('.bat filen er ikke pen. WTF?');
    sprintf('Error message. %s', errmsg);
end

if(fbat>=0)
    %Batch kommandoer som kjrer PLAXIS. (Dir Plaxis - dir prosjekt - kjr
    %.Log-fil)
    for j=Start:Slutt
       fprintf(fbat,['"D:\\PLAXIS 2D\\PLAXIS\\Plaxis2DXInput.exe" "C:\\Users\\mordi\\Documents\\PLAXIS\\Leistad.p2dx" "--run=D:\\Skole\\Var 2014\\PlaxisCommands\\LOGfiler\\calculate' sprintf('%4.4d',j) '.log"\r\n']);
       %fprintf(fbat,['"D:\\Skole\\Var 2014\\PlaxisCommands\\copyresults.exe"\r\n']);
       fprintf(fbat,['rename C:\\Users\\mordi\\Documents\\PLAXIS\\Leistad.p2dxdat\\data.c01 data' sprintf('%4.4d',j) '.c01 \r\n']); %Denne skal gi nytt navn til en fil...
       fprintf(fbat,['xcopy /s "C:\\Users\\mordi\\Documents\\PLAXIS\\Leistad.p2dxdat\\data' sprintf('%4.4d',j) '.c01" "D:\\Skole\\Var 2014\\PlaxisCommands\\ResultaterLognormal"\r\n']);
       fprintf(fbat,['del "C:\\Users\\mordi\\Documents\\PLAXIS\\Leistad.p2dxdat\\data' sprintf('%4.4d',j) '.c01"\r\n']);
    end
end
fclose(fbat); %Lukker .bat filen.


